#include "mbed.h"  
  
int samplingTime = 280;//280 microseconds
int deltaTime = 40;//40 us to give total pulse width of 0.32ms
int sleepTime = 9680;//LED off for 9680 us to take 1 measurement per second


float computeDust(AnalogIn* dustAnal,DigitalOut* dustDig) {
  dustDig->write(0); // power on the LED
  wait_us(samplingTime);
 
  float voMeasured = dustAnal->read(); // read the dust value
  wait_us(deltaTime);
  
  dustDig->write(1); // turn the LED off
  wait_us(sleepTime);
 
  // 0 - 5V mapped to 0 - 1023 integer values
  // recover voltage
  float calcVoltage = voMeasured*5.0; // 3.3
 
  // linear eqaution taken from http://www.howmuchsnow.com/arduino/airquality/
  // Chris Nafis (c) 2012
  float dustDensitySharp = 0.5/2.8 * (float(calcVoltage) - 0.7);
 
  return dustDensitySharp;
}